#ifndef _DECL_barrier_H_
#define _DECL_barrier_H_
#include "charm++.h"
/* DECLS: message FP;
 */
class FP;
class CMessage_FP:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t,void*p) { return p; }
    void* operator new(size_t,const int);
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p,void*){CkFreeMsg(p);}
    void operator delete(void*p,const int){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p,int*,const int){CkFreeMsg(p);}
    void operator delete(void*p,int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p,size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t,int*,int);
    CMessage_FP() {};
    static void *pack(FP *p);
    static FP* unpack(void* p);
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: group barrier: IrrGroup{
barrier(void);
void notify(void);
void callFP(void);
void reset(void);
void atBarrier(FP* impl_msg);
};
 */
 class barrier;
 class CkIndex_barrier;
 class CProxy_barrier;
 class CProxyElement_barrier;
/* --------------- index object ------------------ */
class CkIndex_barrier{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: barrier(void);
 */
    static int __idx_barrier_void;
    static int ckNew(void) { return __idx_barrier_void; }
    static void _call_barrier_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void notify(void);
 */
    static int __idx_notify_void;
    static int notify(void) { return __idx_notify_void; }
    static void _call_notify_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void callFP(void);
 */
    static int __idx_callFP_void;
    static int callFP(void) { return __idx_callFP_void; }
    static void _call_callFP_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void reset(void);
 */
    static int __idx_reset_void;
    static int reset(void) { return __idx_reset_void; }
    static void _call_reset_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void atBarrier(FP* impl_msg);
 */
    static int __idx_atBarrier_FP;
    static int atBarrier(FP* impl_msg) { return __idx_atBarrier_FP; }
    static void _call_atBarrier_FP(void* impl_msg,barrier* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxyElement_barrier: public CProxyElement_IrrGroup{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    CProxyElement_barrier(void) {}
    CProxyElement_barrier(const IrrGroup *g) : CProxyElement_IrrGroup(g){  }
    CProxyElement_barrier(CkGroupID _gid,int _onPE,CkGroupID dTo) : CProxyElement_IrrGroup(_gid,_onPE,dTo){  }
    CProxyElement_barrier(CkGroupID _gid,int _onPE) : CProxyElement_IrrGroup(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_IrrGroup)
    void ckDelegate(CkDelegateMgr *to) {
      CProxyElement_IrrGroup::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxyElement_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_IrrGroup::ckSetGroupID(g);
    }
    barrier* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static barrier* ckLocalBranch(CkGroupID gID) {
      return (barrier*)CkLocalBranch(gID);
    }
/* DECLS: barrier(void);
 */

/* DECLS: void notify(void);
 */
    void notify(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }

/* DECLS: void callFP(void);
 */
    void callFP(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }

/* DECLS: void reset(void);
 */
    void reset(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }

/* DECLS: void atBarrier(FP* impl_msg);
 */
    void atBarrier(FP* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }
};
PUPmarshall(CProxyElement_barrier);
/* ---------------- collective proxy -------------- */
class CProxy_barrier: public CProxy_IrrGroup{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    CProxy_barrier(void) {}
    CProxy_barrier(const IrrGroup *g) : CProxy_IrrGroup(g){  }
    CProxy_barrier(CkGroupID _gid,CkGroupID dTo) : CProxy_IrrGroup(_gid,dTo){  }
    CProxy_barrier(CkGroupID _gid) : CProxy_IrrGroup(_gid){  }
    CProxyElement_barrier operator[](int onPE) const
      {return CProxyElement_barrier(ckGetGroupID(),onPE,ckDelegatedIdx());}
   CK_DISAMBIG_GROUP(CProxy_IrrGroup)
    void ckDelegate(CkDelegateMgr *to) {
      CProxy_IrrGroup::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxy_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_IrrGroup::ckSetGroupID(g);
    }
    barrier* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static barrier* ckLocalBranch(CkGroupID gID) {
      return (barrier*)CkLocalBranch(gID);
    }
/* DECLS: barrier(void);
 */
    static CkGroupID ckNew(void);

/* DECLS: void notify(void);
 */
    void notify(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_barrier::__idx_notify_void, impl_msg, ckGetGroupID());
    }
    void notify(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_barrier::__idx_notify_void, impl_msg, npes, pes, ckGetGroupID());
    }

/* DECLS: void callFP(void);
 */
    void callFP(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_barrier::__idx_callFP_void, impl_msg, ckGetGroupID());
    }
    void callFP(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_barrier::__idx_callFP_void, impl_msg, npes, pes, ckGetGroupID());
    }

/* DECLS: void reset(void);
 */
    void reset(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_barrier::__idx_reset_void, impl_msg, ckGetGroupID());
    }
    void reset(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_barrier::__idx_reset_void, impl_msg, npes, pes, ckGetGroupID());
    }

/* DECLS: void atBarrier(FP* impl_msg);
 */
    void atBarrier(FP* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, ckGetGroupID());
    }
    void atBarrier(FP* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_barrier::__idx_atBarrier_FP, impl_msg, npes, pes, ckGetGroupID());
    }
};
PUPmarshall(CProxy_barrier);
typedef CBaseT<Group,CProxy_barrier>  CBase_barrier;

extern void _registerbarrier(void);
#endif
